using System.ComponentModel.DataAnnotations;

namespace ExperienceEfCore
{
    public class NonNegativePriceAttribute : ValidationAttribute
    {
        protected override ValidationResult IsValid(object value, ValidationContext validationContext)
        {
            if (value == null)
            {
                return ValidationResult.Success;
            }
            if (value is int price && price < 0)
            {
                return new ValidationResult("Price must be non-negative");
            }
            return ValidationResult.Success;
        }
    }
}