using Microsoft.AspNetCore.Mvc;
using ExperienceEfCore.Models;
using ExperienceEfCore.Services;
using ExperienceEfCore.Data;
using System.Runtime.CompilerServices;
using System.Security.Claims;
using Microsoft.AspNetCore.Authorization;



namespace ExperienceEfCore.Controllers;

[Authorize]
[ApiController]
[Route("[controller]")]
public class ProviderController : ControllerBase
{
    private MyDbContext _context;

    public ProviderController(MyDbContext context){
        _context = context;
    }

    [Authorize(Policy = "ManagerOnly")]
    [HttpGet]
    public ActionResult<Provider> GetAllProviders(MyDbContext context)
    {
        var providers = ProviderService.GetAllProviders(context);

        if (providers == null)
        {
            return NotFound();
        }
        return Ok(providers);
    }
}
