using Microsoft.AspNetCore.Mvc;
using ExperienceEfCore.Models;
using ExperienceEfCore.Services;
using ExperienceEfCore.Data;
using Microsoft.AspNetCore.Authorization;


namespace ExperienceEfCore.Controllers;

[Authorize]
[ApiController]
[Route("[controller]")]
public class SharedExperienceController : ControllerBase
{
    private MyDbContext _context;

    public SharedExperienceController(MyDbContext context){
        _context = context;
    }

    [AllowAnonymous]
    [HttpGet]
    public ActionResult<SharedExperience> GetAllSharedExperiencesOrderedByDate(MyDbContext context)
    {
        var se = SharedExperienceServices.GetAllSharedExperiencesOrderedByDate(_context);
        if (se == null)
        {
            return NotFound();
        }
        return Ok(se);
    }
}
