﻿using ExperienceEfCore.Models;
using Microsoft.AspNetCore.Identity.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore;

namespace ExperienceEfCore.Data
{
    public class MyDbContext : IdentityDbContext<ApiUser>
    {
        private readonly string _connectionString;
        public MyDbContext(DbContextOptions<MyDbContext> options) : base(options)
        {
            // Usersecret setup
            var configuration = new ConfigurationBuilder()
                .SetBasePath(AppContext.BaseDirectory)
                .AddUserSecrets<MyDbContext>()
                .Build();
            _connectionString = configuration["UserSecretBAD2"]; // Name of usersecret
        }

        internal DbSet<Experience> Experiences { get; set; }
        internal DbSet<SharedExperience> SharedExperiences { get; set; }
        internal DbSet<Guest> Guests { get; set; }
        internal DbSet<Provider> Providers { get; set; }

      
        protected override void OnConfiguring(DbContextOptionsBuilder options) 
        => options.UseSqlServer(_connectionString);
    }
}
