using ExperienceEfCore.Data;
using ExperienceEfCore.Models;
using ExperienceEfCore.Services;
using Microsoft.EntityFrameworkCore;
using Microsoft.AspNetCore.Identity;
using Microsoft.EntityFrameworkCore.Diagnostics;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using System.Runtime.CompilerServices;
public static class SystemService
{   
    public static void SeedDatabase(MyDbContext context)
    {
        //seed database 

        //Providers
        var p1 = new Provider { BusinessAddress = "Finlandsgade 17, 8200 Aarhus N", PhoneNo = "+45 71555080" };

        context.Providers.Add(p1);

        //Experiences
        var e1 = new Experience { Name = "Night at Noahs Hotel Single room", Description = "Spend the night at Noahs Hotel", Price = 730, Provider = p1 };
        var e2 = new Experience { Name = "Night at Noahs Hotel Double room", Description = "Spend the night at Noahs Hotel", Price = 910, Provider = p1 };
        var e3 = new Experience { Name = "Flight AAR - VIE", Description = "Flight", Price = 1000, Provider = p1 };
        var e4 = new Experience { Name = "Vienna Historic Center Walking Tour", Description = "Walk", Price = 100, Provider = p1 };

        context.Experiences.AddRange(e1, e2, e3, e4);

        // Guests
        var g1 = new Guest { PhoneNo = "+45 1234 5678", Age = 30, Name = "Joan" };
        var g2 = new Guest { PhoneNo = "+45 2345 6789", Age = 25, Name = "Suzzane" };
        var g3 = new Guest { PhoneNo = "+45 3456 7890", Age = 40, Name = "Patrick" };
        var g4 = new Guest { PhoneNo = "+45 3456 7890", Age = 40, Name = "Anne" };

        context.Guests.AddRange(g1, g2, g3, g4);


        // SharedExperiences
        var se1 = new SharedExperience { Title = "Trip to Austria", Date = "2024-07-02" };
        var se2 = new SharedExperience { Title = "Dinner Downtown", Date = "2024-04-07" };
        var se3 = new SharedExperience { Title = "Pottery Weekend", Date = "2024-03-22" };

        // Add shared experiences to the context
        context.SharedExperiences.AddRange(se1, se2, se3);


        // Link Experiences to the "Trip to Austria" SharedExperience
        se1.Experiences.Add(e1);
        se1.Experiences.Add(e3);
        se1.Experiences.Add(e4);

        // Link guests to shared experience
        se1.Guests.Add(g1);
        se1.Guests.Add(g2);
        se1.Guests.Add(g3);
        se1.Guests.Add(g4);

        // Link Guests to experiences
        g1.Experiences.Add(e4); // Joan -> Vienna Historic Center Walking Tour
        g2.Experiences.Add(e4); // Suzzane -> Vienna Historic Center Walking Tour

        g1.Experiences.Add(e1); // Joan -> Night at Noahs Hotel Single room
        g2.Experiences.Add(e1); // Suzzane -> Night at Noahs Hotel Single room
        g3.Experiences.Add(e1); // Patrick -> Night at Noahs Hotel Single room
        g4.Experiences.Add(e1); // Anne -> Night at Noahs Hotel Single room

        g1.Experiences.Add(e3); // Joan -> Flight AAR - VIE
        g2.Experiences.Add(e3); // Suzzane -> Flight AAR - VIE
        g3.Experiences.Add(e3); // Patrick -> Flight AAR - VIE
        g4.Experiences.Add(e3); // Anne -> Flight AAR - VIE

        // Save changes
        context.SaveChanges();
    }
}